SystemOrganization addCategory: #'LiCoR-Tests'!

TestCase subclass: #CoreTests
	instanceVariableNames: ''
	classVariableNames: 'Test'
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!CoreTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
methodForClass: aClass selector: aSymbol
	"Return a method reification. Makes sure that this works for the representation with a SmalltalkMethod and for the CompiledMethod."

	
	^(MLI current methodsInClass: aClass) detect: [:m | m selector = aSymbol]! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'sp 24/10/11 15:26'!
testAllSourceComments
	
	| wrappedMethod |
	wrappedMethod := self methodForClass: TestClass5 selector:
			#commentedMethod0.
	self assert: wrappedMethod allSourceComments size = 0.
	wrappedMethod := self methodForClass: TestClass5 selector:
			#commentedMethod1.
	self assert: wrappedMethod allSourceComments size = 1.
	self
		assert:
			wrappedMethod allSourceComments first = 'This method has one comment'.
	wrappedMethod := self methodForClass: TestClass5 selector:
			#commentedMethod3.
	self assert: wrappedMethod allSourceComments size = 3.
	self assert: (wrappedMethod allSourceComments includes: 'fun').
	self assert: (wrappedMethod allSourceComments includes: 'Smalltalk').
	self assert: (wrappedMethod allSourceComments includes: 'is')! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'AndyKellens 11/2/2011 09:53'!
testClassReferences
	"self run: #testClassReferences"

	"self debug: #testClassReferences"

	
	| aStMethodTerm |
	Test := Array.
	aStMethodTerm := self
		methodForClass: self class
		selector: #zork.
	self
		assert:
			aStMethodTerm classesReferenced asOrderedCollection
				= (OrderedCollection with: SoulFactory with: Array).
	aStMethodTerm := self methodForClass: Constant selector:
			#resolveIn:startAt:.
	self
		assert:
			aStMethodTerm classesReferenced asOrderedCollection
				= (OrderedCollection with: SoulFactory)! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'sp 24/10/11 15:26'!
testCreation
	"self run: #testCreation"

	"self debug: #testCreation"

	
	| aStMethodTerm |
	aStMethodTerm := self methodForClass: AbstractTerm selector: #printOn:.
	self assert: aStMethodTerm fromClass = AbstractTerm.
	self assert: aStMethodTerm selector = #printOn:! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'sp 24/10/11 15:26'!
testIsAbstract
	"self run: #testIsAbstract"

	"self debug: #testIsAbstract"

	
	| aStMethodTerm |
	aStMethodTerm := self methodForClass: AbstractTerm selector: #printOn:.
	self assert: aStMethodTerm isAbstract! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'sp 24/10/11 15:26'!
testIsAbstractFailing
	"self run: #testIsAbstractFailing"

	"self debug: #testIsAbstractFailing"

	
	| aStMethodTerm |
	aStMethodTerm := self methodForClass: Constant selector: #printOn:.
	self deny: aStMethodTerm isAbstract! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'sp 24/10/11 15:26'!
testIsAbstractSucceeding
	"self run: #testIsAbstract"

	"self debug: #testIsAbstract"

	
	| aStMethodTerm |
	aStMethodTerm := self methodForClass: AbstractTerm selector: #printOn:.
	self assert: aStMethodTerm isAbstract! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'sp 24/10/11 15:26'!
testMessagesSent
	"self run: #testMessagesSent"

	"self debug: #testMessagesSent"

	
	| aStMethodTerm messagesSent |
	aStMethodTerm := self methodForClass: AbstractTerm selector: #printOn:.
	self
		assert:
			aStMethodTerm messages asOrderedCollection
				= (OrderedCollection with: #subclassResponsibility).
	aStMethodTerm := self methodForClass: Constant selector:
			#resolveIn:startAt:.
	messagesSent := OrderedCollection withAll:
			#(#fromClause:toClauses:inEnv:startAt: #normalAddressLookup:multiplicity: #lexicalAddressInEnv:startAt:ifAbsent: #definitionRepository #clauseNotFoundIn:inEnv:startAt: #current #makeResolver).
	self
		assert:
			((aStMethodTerm messages asOrderedCollection)
				removeAll: messagesSent;
				yourself) isEmpty! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'sp 24/10/11 15:26'!
testRbParseTree
	
	| aStMethodTerm |
	aStMethodTerm := self methodForClass: Constant selector:
			#resolveIn:startAt:.
	self assert: (aStMethodTerm rbParseTree isKindOf: RBMethodNode)! !

!CoreTests methodsFor: 'smalltalk method term' stamp: 'AndyKellens 11/2/2011 09:53'!
testReferencesClass
	"self run: #testReferencesClass"

	"self debug: #testReferencesClass"

	
	| aStMethodTerm |
	aStMethodTerm := self methodForClass: Constant selector:
			#resolveIn:startAt:.
	self assert: (aStMethodTerm referencesClass: SoulFactory).
	self deny: (aStMethodTerm referencesClass: Object)! !

!CoreTests methodsFor: 'test method' stamp: 'AndyKellens 11/2/2011 09:53'!
zork
	
	| temp |
	temp := SoulFactory current makeVariable.
	temp halt: 'Aaaarrgghhhhhh!! I am not meant to be executed!!'.
	^temp environment = Test! !

TestCase subclass: #FixedNrCacheTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!FixedNrCacheTests methodsFor: 'fixedNr tests' stamp: 'sp 24/10/11 15:26'!
testBasicNrCache
	"Test the basic adding and overflowing in a FixedNrCache."

	
	| cache |
	cache := FixedNrCache new.
	cache maxSize: 3.
	cache at: #one put: 1.
	self assert: cache currentSize = 1.
	self assert: (cache includesKey: #one).
	cache at: #two put: 2.
	self assert: cache currentSize = 2.
	self assert: (cache includesKey: #one).
	self assert: (cache includesKey: #two).
	cache at: #three put: 3.
	self assert: cache currentSize = 3.
	self assert: (cache includesKey: #one).
	self assert: (cache includesKey: #two).
	self assert: (cache includesKey: #three).
	cache at: #four put: 4.
	self assert: cache currentSize = 3.
	self deny: (cache includesKey: #one).
	self assert: (cache includesKey: #two).
	self assert: (cache includesKey: #three).
	self assert: (cache includesKey: #four)! !

!FixedNrCacheTests methodsFor: 'fixedNr tests' stamp: 'sp 24/10/11 15:26'!
testNrCache
	
	| cache |
	cache := FixedNrCache new.
	cache maxSize: 3.
	self assert: (cache at: #one ifAbsentPut: 1) = 1.
	self assert: cache currentSize = 1.
	self assert: (cache includesKey: #one).
	self assert: (cache at: #one ifAbsentPut: 1) = 1.
	self assert: cache currentSize = 1.
	self assert: (cache includesKey: #one).
	self assert: (cache at: #two ifAbsentPut: 2) = 2.
	self assert: cache currentSize = 2.
	self assert: (cache includesKey: #one).
	self assert: (cache includesKey: #two).
	cache clear.
	self assert: cache currentSize = 0.
	self assert: cache maxSize = 3! !

!FixedNrCacheTests methodsFor: 'fixedNr tests' stamp: 'sp 24/10/11 15:26'!
testNrCacheRemoval
	
	| cache |
	cache := FixedNrCache new.
	cache maxSize: 3.
	self assert: (cache at: #one ifAbsentPut: 1) = 1.
	self assert: (cache at: #two ifAbsentPut: 2) = 2.
	self assert: (cache at: #three ifAbsentPut: 3) = 3.
	cache removeKey: #two.
	self assert: cache currentSize = 2.
	self assert: (cache includesKey: #one).
	self deny: (cache includesKey: #two).
	self assert: (cache includesKey: #three).
	self assert: (cache at: #four ifAbsentPut: 4) = 4.
	self assert: (cache at: #five ifAbsentPut: 5) = 5.
	self assert: cache currentSize = 3.
	self assert: (cache includesKey: #three).
	self assert: (cache includesKey: #four).
	self assert: (cache includesKey: #five).
	self
		should: [cache remove: 2]
		raise: Error.
	cache remove: 3.
	self assert: cache currentSize = 2.
	self deny: (cache includesKey: #three).
	self assert: (cache includesKey: #four).
	self assert: (cache includesKey: #five).
	cache removeOldest.
	self assert: cache currentSize = 1.
	self deny: (cache includesKey: #four).
	self assert: (cache includesKey: #five).
	cache replace: 5 with: 50.
	self assert: cache currentSize = 1.
	self
		assert:
			(cache
				at: #five
				ifAbsentPut: [0]) = 50! !

!FixedNrCacheTests methodsFor: 'fixedNr tests' stamp: 'sp 24/10/11 15:26'!
testResizingNrCache
	"Test the basic adding and overflowing in a FixedNrCache."

	
	| cache |
	cache := FixedNrCache new.
	cache maxSize: 3.
	cache at: #one put: 1.
	cache at: #two put: 2.
	cache at: #three put: 3.
	cache at: #four put: 4.
	cache maxSize: 5.
	self assert: cache currentSize = 3.
	self assert: cache maxSize = 5.
	cache at: #five put: 5.
	cache at: #six put: 6.
	self assert: cache currentSize = 5.
	self assert: cache maxSize = 5.
	cache maxSize: 2.
	self assert: cache currentSize = 2.
	self assert: cache maxSize = 2.
	self assert: (cache includesKey: #five).
	self assert: (cache includesKey: #six)! !

LogicTests subclass: #BasicReasoningTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!BasicReasoningTests commentStamp: '<historical>' prior: 0!
self suite run

!

!BasicReasoningTests class methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
methodForCode: aString
	"Take aString, and return a method for that string. This is used for tests that need to generate methods on the fly. Otherwise those methods have to be stored on test classes all the time, which is not always desired."

	
	^Compiler new
		compile: aString
		in: nil
		allowReceiver: true
		class: nil class
		environment: Smalltalk
		noPattern: false
		notifying: nil
		ifFail: [^nil]! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addTestPackage1
	
	| testPackage previousPackage |
	previousPackage := Registry currentPackage.
	testPackage := PackageModel named: 'TestPackage1'.
	Registry currentPackage: testPackage.
	Soul defineClass: #PackageTestClass1 superclass: Object indexedType: #none
		private: false instanceVariableNames: '' classInstanceVariableNames: ''
		imports: '' category: 'Soul-LogicTestClasses'.
	Registry currentPackage: previousPackage! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addTestPackage2
	
	| testPackage previousPackage |
	previousPackage := Registry currentPackage.
	testPackage := PackageModel named: 'TestPackage2'.
	Registry currentPackage: testPackage.
	Soul defineClass: #PackageTestClass2 superclass: PackageTestClass1
		indexedType: #none private: false instanceVariableNames: ''
		classInstanceVariableNames: '' imports: '' category:
			'Soul-LogicTestClasses'.
	Registry currentPackage: previousPackage! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addTestPackage3
	
	| testPackage previousPackage |
	previousPackage := Registry currentPackage.
	testPackage := PackageModel named: 'TestPackage3'.
	Registry currentPackage: testPackage.
	Soul defineClass: #PackageTestClass3 superclass: PackageTestClass2
		indexedType: #none private: false instanceVariableNames: ''
		classInstanceVariableNames: '' imports: '' category:
			'Soul-LogicTestClasses'.
	Registry currentPackage: previousPackage! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addTestPackages1And2
	
	self removeTestPackages1And2.
	self addTestPackage1.
	self addTestPackage2! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addTestPackages1And2And3
	
	self removeTestPackages1And2And3.
	self addTestPackage1.
	self addTestPackage2.
	self addTestPackage3! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
removeTestPackage1
	
	PackageTestClass1 ifDefinedDo: [:cl | cl removeFromSystem].
	Registry removePackage: (Registry packageNamed: 'TestPackage1')! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
removeTestPackage2
	
	PackageTestClass2 ifDefinedDo: [:cl | cl removeFromSystem].
	Registry removePackage: (Registry packageNamed: 'TestPackage2')! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
removeTestPackage3
	
	PackageTestClass3 ifDefinedDo: [:cl | cl removeFromSystem].
	Registry removePackage: (Registry packageNamed: 'TestPackage3')! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
removeTestPackages1And2
	
	self removeTestPackage2.
	self removeTestPackage1! !

!BasicReasoningTests methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
removeTestPackages1And2And3
	
	self removeTestPackage3.
	self removeTestPackage2.
	self removeTestPackage1! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testAreArgumentsOfMethod2
	
	self processQuery:
			' if succeeds(and(?method isMethodWithName: array inClass: [TestClass1],<> areArgumentsOfMethod: ?method))'
		description: 'checks whether Soul.TestClass1>>array has no arguments'.
	self processQuery:
			' if succeeds(and(?method isMethodWithName: [#array:] inClass: [TestClass1],<RBVariableNode(anArray)> areArgumentsOfMethod: ?method))'
		description:
			'checks whether Soul.TestClass1>>array: has a single argument called anArray'.
	self processQuery:
			' if succeeds(and(?method isMethodWithName: [#complexWith:and:and:and:] inClass: [TestClassRoot],<RBVariableNode(modifiers),RBVariableNode(bindings),RBVariableNode(specificImports),RBVariableNode(generalImports)> areArgumentsOfMethod: ?method))'
		description:
			'checks whether Soul.TestClassRoot>>complexWith:and:and:and: has a four arguments'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testAreStatementsOfMethod2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: methodWithSend inClass: [TestClassRoot],<?statement> areStatementsOfMethod: ?Method))'
		description: 'This method has a single statement.'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?statements areStatementsOfMethod: ?Method,length(?statements,2)))'
		description: 'This method has two statements.'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [SubClass1],<> areStatementsOfMethod: ?Method))'
		description: 'This method has no statements.'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testClassCallsMethod2
	
	self processQuery:
			' if succeeds(and(?M isMethodWithName: methodWithAssignment inClass: [TestClassRoot],[TestClassRoot] classCallsMethod: ?M))'
		description:
			'Verify that this class calls a method named methodWithAssignment'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testClassImplementsSelector2
	
	self processQuery: ' if [TestClass1] classImplementsSelector: array'
		description:
			'Tests whether classImplements correctly determines that TestClass1 implements a method named #array'.
	self processQuery:
			' if ?c classImplementsSelector: array,?c equals: [TestClass1]'
		description:
			'Tests whether TestClass1 is one of the solutions when checking for implementers of #array'.
	self processQuery:
			' if [TestClass1] classImplementsSelector: ?s,?s equals: array'
		description:
			'Tests whether #array is one of the solutions when checking for the selectors implemented by TestClass1'.
	self processQuery:
			' if not([TestClass1] classImplementsSelector: veryUnlikelyNameForAMethod)'
		description:
			'Tests whether classImplements correctly determines that TestClass1 does not implement a certain method'.
	self processQuery:
			' if [Object] classImplementsSelector: shouldNotImplement' description:
			'Tests whether classImplements correctly determines that Object implements a method named #shouldNotImplement'.
	self processQuery:
			' if not(?c classImplementsSelector: shouldNotImplement,not(?c equals: [Object]))'
		description:
			'Tests that the Object class is the only result returned when searching for classes that implement #shouldNotImplement'.
	self processQuery:
			' if not([TestClass1] classImplementsSelector: ?selector,not([TestClass1] classImplementsSelector: ?selector))'
		description:
			'Sanity test for optimized implementations of classImplements that have seperate cases depending on whether ?selector is bound or not: solutions generated by leaving ?selector unbound should make the predicate hold as well in the bound case'.
	self processQuery:
			' if not(?class classImplementsSelector: #at:put:,not(?class classImplementsSelector: #at:put:))'
		description:
			'Sanity test for optimized implementations of classImplements that have seperate cases depending on whether ?class is bound or not: solutions generated by leaving ?class unbound should make the predicate hold as well in the bound case'.
	self processQuery: ' if one(?class classImplementsSelector: ?selector)'
		description:
			'Sanity test for optimized implementations of classImplements that have seperate cases for the different bound status of its variables: leaving both variables unbound should at least generate one solution and not simply fail'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testClassInheritsFrom2
	
	self
		processQuery: ' if ?SubClass classInheritsFrom: [TestClass1]'
		resultsCheck: [:results | results size = 2]
		description: 'Are there two classes in the hierarchy of TestClass1'.
	self processQuery:
			' if fails([TestClass1] classInheritsFrom: [TestClass1])' description:
			'Does TestClass1 belong to its own hierarchy?'.
	self processQuery:
			' if succeeds([SubClass1] classInheritsFrom: [TestClass1])' description:
			'Does SubClass1 belong to the hierarchy of TestClass1?'.
	self processQuery:
			' if succeeds([SubClass2] classInheritsFrom: [TestClass1])' description:
			'Does SubClass2 belong to the hierarchy of TestClass1?'.
	self
		processQuery: ' if ?SubClass classInheritsFrom: [TestClass2]'
		resultsCheck: [:results | results size = 0]
		description: 'There is no class inheriting from TestClass2'.
	self processQuery:
			' if fails([TestClass2] classInheritsFrom: [TestClass2])' description:
			'Does TestClass2 belong to its own hierarchy?'.
	self
		processQuery: ' if [SubClass1] classInheritsFrom: ?Root'
		resultsCheck: [:results | results size >= 2]
		description:
			'Are there at least two classes above SubClass1 (including SubClass1 itself)?'.
	self processQuery: ' if succeeds(one(?SubClass classInheritsFrom: ?Root))'
		description: 'Does classInheritsFrom:/2 work with two unbound arguments?'.
	self processQuery:
			' if fails(?SubClass classInheritsFrom: [ThisIsANoneExistingClass])'
		description:
			'Does classInheritsFrom:/2 fail when the root class is non existent?'.
	self processQuery:
			' if fails([ThisIsANoneExistingClass] classInheritsFrom: ?Root)'
		description:
			'Does classInheritsFrom:/2 fail when the child class is non existent?'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testClassUnderstandsSelector2
	
	self processQuery:
			' if succeeds([Object] classUnderstandsSelector: [#at:put:])'
		description: 'Does object understand #at:put: ?'.
	self processQuery:
			' if succeeds(?class classUnderstandsSelector: [#at:put:])' description:
			'Can we collect all classes understanding #at:put: ?'.
	self processQuery:
			' if succeeds(and(?class classUnderstandsSelector: [#at:put:],?class equals: [OrderedCollection]))'
		description:
			'Is OrderedCollection one of the classes understanding #at:put: ?'.
	self processQuery:
			' if succeeds([TestClass1] classUnderstandsSelector: array)'
		description: 'Direct implementation'.
	self processQuery:
			' if succeeds([SubClass1] classUnderstandsSelector: array)' description:
			'Indirect implementation'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testIsAbstractClass
	
	self processQuery: ' if succeeds([TestClassRoot] isAbstractClass)'
		description:
			'This class is abstract because it implements an abstract method'.
	self processQuery: ' if succeeds([SubClass3] isAbstractClass)'
		description:
			'This class is abstract because it parent has an abstract method'.
	self processQuery: ' if fails([ConcreteSubClass] isAbstractClass)'
		description:
			'This class provides an implementation for all abstract methods'.
	self processQuery: ' if succeeds([AbstractSubclass] isAbstractClass)'
		description:
			'This class provides an implementation for all but one of its parents abstract methods'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsAbstractMethod1
	
	self processQuery:
			' if succeeds(and(?method isMethodWithName: anAbstractMethod inClass: [TestClass3],?method isAbstractMethod))'
		description:
			'checks whether Soul.TestClass3>>anAbstractMethod is an abstract method'.
	self processQuery:
			' if succeeds(and(?method isMethodWithName: anotherAbstractMethod inClass: [TestClass3],?method isAbstractMethod))'
		description:
			'checks whether Soul.TestClass3>>anotherAbstractMethod is an abstract method'.
	self processQuery:
			' if fails(and(?method isMethodWithName: aMethod1 inClass: [TestClass3],?method isAbstractMethod))'
		description:
			'checks whether Soul.TestClass3>>aMethod1 is an abstract method'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsCancelledMethod1
	
	self processQuery:
			' if succeeds(and(?method isMethodWithName: anUnimplementedMethod inClass: [TestClass3],?method isCancelledMethod))'
		description:
			'checks whether Soul.TestClass3>>anUnimplementedMethod is an abstract method'.
	self processQuery:
			' if succeeds(and(?method isMethodWithName: ? inClass: [TestClass3],?method isCancelledMethod))'
		description: 'Can we find cancelled methods in class TestClass3?'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testIsClassAbove2
	
	self processQuery: ' if fails([TestClass1] isClassAbove: [TestClass1])'
		description: 'A class not be above itself.'.
	self processQuery: ' if fails([SubClass1] isClassAbove: [TestClass1])'
		description: 'Is SubClass1 not in the hierarchy above TestClass1?'.
	self processQuery: ' if [TestClass1] isClassAbove: [SubClass1]'
		description: 'Is TestClass1 in the hierarchy above SubClass1?'.
	self processQuery:
			' if fails(and(?root isRootClass,?SuperClass isClassAbove: ?root))'
		description: 'There are no classes above a root class.'.
	self processQuery: ' if succeeds(?SuperClass isClassAbove: ?Class)'
		description: 'Does isClassAbove:/2 work with two unbound arguments?'.
	self processQuery:
			' if fails(?Class isClassAbove: [ThisIsANoneExistingClass])'
		description:
			'Does isClassAbove:/2 fail when the lower class is non existent?'.
	self processQuery:
			' if fails([ThisIsANoneExistingClass] isClassAbove: ?Class)'
		description:
			'Does isClassAbove:/2 fail when the ancestor class is non existent?'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testIsClassBelow2
	
	self
		processQuery: ' if ?SubClass isClassBelow: [TestClass1]'
		resultsCheck: [:results | results size = 2]
		description:
			'Are there three classes in the hierarchy BELOW TestClass1 (i.e. all descendants of TestClass1 excluding itself.'.
	self
		processQuery: ' if ?SubClass isClassBelow: [TestClass3]'
		resultsCheck: [:results | results size = 3]
		description: 'Are there three classes in the hierarchy BELOW TestClass3'.
	self processQuery: ' if fails([TestClass1] isClassBelow: [TestClass1])'
		description: 'A class not be below itself.'.
	self processQuery: ' if succeeds([SubClass1] isClassBelow: [TestClass1])'
		description: 'Is SubClass1 in the hierarchy below TestClass1?'.
	self processQuery: ' if succeeds([SubClass2] isClassBelow: [TestClass1])'
		description: 'Is SubClass2 in the hierarchy below TestClass1?'.
	self processQuery: ' if fails(?SubClass isClassBelow: [TestClass2])'
		description: 'There no classes in the hierarchy BELOW TestClass2.'.
	self
		processQuery: ' if [SubClass1] isClassBelow: ?Root'
		resultsCheck: [:results | results size >= 3]
		description:
			'Are there at least three classes ABOVE SubClass1 (excluding SubClass1 itself)?'.
	self processQuery: ' if succeeds(?SubClass isClassBelow: ?Root)'
		description: 'Does classBelow/2 work with two unbound arguments?'.
	self processQuery:
			' if fails(?SubClass isClassBelow: [ThisIsANoneExistingClass])'
		description:
			'Does classBelow/2 fail when the root class is non existent?'.
	self processQuery:
			' if fails([ThisIsANoneExistingClass] isClassBelow: ?Root)' description:
			'Does classBelow/2 fail when the child class is non existent?'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testIsClassInHierarchyOf2
	
	self
		processQuery: ' if ?SubClass isClassInHierarchyOf: [TestClass1]'
		resultsCheck: [:results | results size = 3]
		description:
			'Are there three classes in the hierarchy of TestClass1 (i.e. TestClass1 itself and two subclasses?'.
	self processQuery:
			' if succeeds([TestClass1] isClassInHierarchyOf: [TestClass1])'
		description: 'Does TestClass1 belong to its own hierarchy?'.
	self processQuery:
			' if succeeds([SubClass1] isClassInHierarchyOf: [TestClass1])'
		description: 'Does SubClass1 belong to the hierarchy of TestClass1?'.
	self processQuery:
			' if succeeds([SubClass2] isClassInHierarchyOf: [TestClass1])'
		description: 'Does SubClass2 belong to the hierarchy of TestClass1?'.
	self
		processQuery: ' if ?SubClass isClassInHierarchyOf: [TestClass2]'
		resultsCheck: [:results | results size = 1]
		description:
			'Is there one class in the hierarchy of TestClass2 (i.e. only TestClass2 itself)'.
	self processQuery:
			' if succeeds([TestClass2] isClassInHierarchyOf: [TestClass2])'
		description: 'Does TestClass2 belong to its own hierarchy?'.
	self processQuery:
			' if fails(and(?SubClass isClassInHierarchyOf: [TestClass2],not(?SubClass equals: [TestClass2])))'
		description: 'Does TestClass2 only contain itself in its hierarchy?'.
	self
		processQuery: ' if [SubClass1] isClassInHierarchyOf: ?Root'
		resultsCheck: [:results | results size >= 3]
		description:
			'Are there at least three classes above SubClass1 (including SubClass1 itself)?'.
	self processQuery:
			' if succeeds(one(?SubClass isClassInHierarchyOf: ?Root))' description:
			'Does isClassInHierarchyOf:/2 work with two unbound arguments?'.
	self processQuery:
			' if fails(?SubClass isClassInHierarchyOf: [ThisIsANoneExistingClass])'
		description:
			'Does isClassInHierarchyOf:/2 fail when the root class is non existent?'.
	self processQuery:
			' if fails([ThisIsANoneExistingClass] isClassInHierarchyOf: ?Root)'
		description:
			'Does isClassInHierarchyOf:/2 fail when the child class is non existent?'! !

!BasicReasoningTests methodsFor: 'naming' stamp: 'AndyKellens 10/25/2011 13:11'!
testIsClassInPackageNamed2
	
	self
		processQuery: ' if ?class isClassInPackageNamed: [''LiCoR-Tests'']'
		resultsCheck:
			[:results | 
			results size = (Smalltalk allClasses select:[:cl | cl category = 'LiCoR-Tests']) size]
		description:
			'Can we get all the classes defined in a package with a given name?'.
	self processQuery:
			' if [PackagingReificationTests] isClassInPackageNamed: {LiCoR-Tests}'
		description: 'Can we test check the name of the package for a class?'.
	self processQuery:
			' if succeeds(and([PackagingReificationTests] isClassInPackageNamed: ?N,?P isPackageWithName: ?N))'
		description: 'Can we get the package for a class?'.
	self processQuery:
			' if succeeds(and([PackagingReificationTests class] isClassInPackageNamed: ?N,?P isPackageWithName: ?N))'
		description: 'Can we get the package for a  metaclass?'.
	self
		processQuery: ' if [Object] isClassInPackageNamed: ?N'
		resultsCheck: [:results | results size = 1]
		description:
			'Does the predicate only returns the package where the class is defined (and not where it is extended)?)'.
	self processQuery: ' if fails([1] isClassInPackageNamed: ?N)' description:
			'Does the predicate fail when not passed a class as first argument'.
	self processQuery: ' if fails(?C isClassInPackageNamed: [1])' description:
			'Does the predicate fail when not passed a string as second argument'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsClassMethod1
	
	self processQuery:
			' if succeeds(and(?method isMethodWithName: aClassMethod inClass: [TestClassRoot class],?method isClassMethod))'
		description:
			'checks whether Soul.TestClassRoot class>>aClassMethod is a class method'.
	self processQuery:
			' if fails(and(?method isMethodWithName: aMethod1 inClass: [TestClass3],?method isClassMethod))'
		description: 'checks whether Soul.TestClass3>>aMethod1 is a class method'! !

!BasicReasoningTests methodsFor: 'naming' stamp: 'sp 24/10/11 15:26'!
testIsClassWithName2
	"self run: #testclassWithName2"

	
	self processQuery:
			' if succeeds(and(?Class isClassWithName: [#Object],nonvar(?Class)))'
		description: 'Can we find a class with a given name?'.
	self processQuery:
			' if succeeds(and(?Class isClassWithName: Object,nonvar(?Class)))'
		description:
			'Can we find a class with a given name? (here we use the shortcut notation for symbols)'.
	self processQuery:
			' if succeeds(and([Object] isClassWithName: ?ClassName,nonvar(?ClassName)))'
		description: 'Can we retrieve the name of a given class?'.
	self processQuery: ' if succeeds([Object] isClassWithName: [#Object])'
		description: 'Can we verify whether a class has a given name?'.
	self processQuery: ' if succeeds([Object] isClassWithName: Object)'
		description:
			'Can we verify whether a class has a given name?  (here we use the shortcut notation for symbols)'.
	self processQuery:
			' if succeeds(one(and(?Class isClassWithName: ?ClassName,nonvar(?Class),nonvar(?ClassName))))'
		description: 'Can we retrieve a class and its name?'.
	self processQuery:
			' if succeeds(and(?Class isClassWithName: [#Object],nonvar(?Class),?Class equals: [Object]))'
		description:
			'Can we find a class with a given name and is it the correct class?'.
	self processQuery:
			' if succeeds(and([Object] isClassWithName: ?ClassName,nonvar(?ClassName),?ClassName equals: [#Object]))'
		description:
			'Can we find the name of a given class and is it the correct name?'.
	self processQuery:
			' if succeeds(and(?Class isClassWithName: [#''Object class''],nonvar(?Class)))'
		description: 'Can we find a meta class with a given name?'.
	self processQuery:
			' if succeeds(and([Object class] isClassWithName: ?ClassName,nonvar(?ClassName)))'
		description: 'Can we find the name of a given meta class?'.
	self processQuery:
			' if succeeds([Object class] isClassWithName: [#''Object class''])'
		description: 'Can we verify whether a meta class has a given name?'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testIsLastMessageInCascade2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?tree isParseTreeOfMethod: ?Method,?cascade isStChildOf: ?tree,zork isLastMessageInCascade: ?cascade))'
		description: 'This method a single cascade that finishes with zork'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?tree isParseTreeOfMethod: ?Method,?cascade isStChildOf: ?tree,[#compile:] isLastMessageInCascade: ?cascade))'
		description: 'This method a single cascade that finishes with zork'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsMethodInClassChainOfClass2
	
	self processQuery:
			' if succeeds(and(?Method isMethodInClassChainOfClass: [TestClass1],?Method isMethodWithName: array))'
		description: 'The class implements the method directly'.
	self processQuery:
			' if succeeds(and(?Method isMethodInClassChainOfClass: [TestClass1],?Method isMethodWithName: foo))'
		description: 'The class implements the method indirectly'.
	self processQuery:
			' if fails(and(?Method isMethodInClassChainOfClass: [TestClass1],?Method isMethodWithName: DOESNOTEXIST))'
		description: 'Method that does not exist'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsMethodInProtocol
	
	self processQuery:
			' if succeeds(and(?Method isMethodInClass: [TestClass1],?Method isMethodInProtocol: ?Protocol))'
		description:
			'Can the predicate isMethodInProtocol:/2 be used with the second argument variable?'.
	self processQuery:
			' if succeeds(and(?Method isMethodInClass: [TestClass1],?Method isMethodInProtocol: ?Protocol,?Protocol equals: [#protocol1]))'
		description:
			'Can the predicate isMethodInProtocol:/2 be used with the second argument variable?'.
	self processQuery:
			' if succeeds(and(?Method isMethodInClass: [TestClass1],?Method isMethodInProtocol: protocol1))'
		description:
			'Can the predicate isMethodInProtocol:/2 be used with the second argument bound?'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsMethodOfClassInProtocol
	
	self processQuery:
			' if succeeds(?Method isMethodInClass: [TestClass1] inProtocol: ?Protocol)'
		description:
			'Can the predicate isMethodInClass:inProtocol:/3 be used to find all methods and protocols in a given class?'.
	self processQuery:
			' if succeeds(and(?Method isMethodInClass: [TestClass1],?Method isMethodInClass: ?Class inProtocol: ?Protocol))'
		description:
			'Can the predicate isMethodInClass:inProtocol:/3 be used to find the class and protocol of a given method?'.
	self processQuery:
			' if succeeds(and(?Method isMethodInClass: [TestClass1],?Method isMethodInClass: ?Class inProtocol: ?Protocol,?Protocol equals: [#protocol1]))'
		description:
			'Can the predicate isMethodInClass:inProtocol:/3 be used to find the class and protocol of a given method?'.
	self processQuery:
			' if succeeds(and(?Method isMethodInClass: [TestClass1],?Method isMethodInClass: ?Class inProtocol: protocol1))'
		description:
			'Can the predicate isMethodInClass:inProtocol:/3 be used to find the class and protocol of a given method?'! !

!BasicReasoningTests methodsFor: 'naming' stamp: 'sp 24/10/11 15:26'!
testIsMethodWithName2
	"self run: #testmethodWithName2"

	
	self processQuery:
			' if succeeds(and(?method isMethodInClass: [TestClass3],?method isMethodWithName: [#anAbstractMethod]))'
		description:
			'The name of TestClass3>>#anAbstractMethod is #anAbstractMethod.'! !

!BasicReasoningTests methodsFor: 'naming' stamp: 'sp 24/10/11 15:26'!
testIsMethodWithNameInClass3
	
	self
		processQuery:
			' if ?Method isMethodWithName: ?Selector inClass: [TestClass1]'
		resultsCheck: [:results | results size = 9]
		description:
			'Can the predicate be used with the first two arguments variable?'.
	self
		processQuery:
			' if ?Method isMethodWithName: [#method1] inClass: [TestClass1]'
		resultsCheck: [:results | results size = 1]
		description:
			'Can we use the predicate to find a method with a given name in a given class?'.
	self
		processQuery:
			' if ?Method isMethodInClass: [TestClass1],?Method isMethodWithName: ?Selector inClass: ?Class,?Class equals: [TestClass1],nonvar(?Selector)'
		resultsCheck: [:results | results size = 9]
		description:
			'Can we use the predicate to find the class and name of a given method?'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsOverriddenSelectorinClass2
	
	self processQuery:
			' if succeeds(foo isOverriddenSelectorInClass: [TestClass4])'
		description: 'foo is overridden'.
	self processQuery:
			' if fails(foo isOverriddenSelectorInClass: [TestClassRoot])'
		description: 'foo is not overridden'.
	self processQuery:
			' if fails(foobar isOverriddenSelectorInClass: [TestClass4])'
		description: 'selector does not exist'.
	self processQuery:
			' if succeeds(foo isOverriddenSelectorInClass: [SubClass1])'
		description: 'indirect (one class in the hierarchy in between) override'! !

!BasicReasoningTests methodsFor: 'naming' stamp: 'AndyKellens 10/25/2011 11:43'!
testIsPackageWithName2
	
	self processQuery:
			' if succeeds(and(?Package isPackageWithName: ?Name,nonvar(?Package),nonvar(?Name)))'
		description: 'Can we use packageWithName/2 with two arguments unbound?'.
	self processQuery:
			' if succeeds(and(?Package isPackageWithName: [''LiCoR-Tests''],nonvar(?Package)))'
		description: 'Can we find the package with a given name?'.
	self processQuery:
			' if succeeds(and([''LiCoR-Tests''] isPackageWithName: ?Name,nonvar(?Name),?Name equals: [''LiCoR-Tests'']))'
		description:
			'Can we find the name of an existing package, and is it the correct one?'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'AndyKellens 10/25/2011 11:16'!
testIsPrimitiveMethod1
	
	self processQuery:
			' if fails(and(?method isMethodWithName: anAbstractMethod inClass: [TestClass3],?method isPrimitiveMethod))'
		description:
			'checks that Soul.TestClass3>>anAbstractMethod is not a primitive method'.
	self processQuery:
			' if succeeds(and(?method isMethodWithName: [#==] inClass: [ProtoObject],?method isPrimitiveMethod))'
		description: 'checks that Object>>== is a primitive method'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsSelector1
	
	self processQuery:
			' if not(thisIsUnlikelyToEveryBeTheSelectorOfAMethod isSelector)'
		description:
			'The symbol #thisIsUnlikelyToEveryBeTheSelectorOfAMethod is not the selector of any method'.
	self processQuery: ' if #printOn: isSelector' description:
			'The symbol #printOn: is known to be a selector'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testIsSelectorOfClassInProtocol
	
	self processQuery:
			' if succeeds(?Selector isSelectorOfClass: [TestClass1] inProtocol: ?Protocol)'
		description:
			'Can the predicate isSelectorOfClass:inProtocol:/3 be used to find all method names and protocols in a given class?'.
	self processQuery:
			' if succeeds([#method4] isSelectorOfClass: ?Class inProtocol: ?Protocol)'
		description:
			'Can the predicate isSelectorOfClass:inProtocol:/3 be used to find all classes and protocols that have a method with a given name?'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: ?Selector inClass: [TestClass1],?Selector isSelectorOfClass: ?Class inProtocol: ?Protocol,?Class equals: [TestClass1],?Protocol equals: [#protocol1]))'
		description:
			'Can the predicate isSelectorOfClass:inProtocol:/3 be used to find the class and protocol of a given selector?'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'AndyKellens 10/25/2011 11:28'!
testIsSourceCodeOfMethod2
	
	self processQuery:
			' if ?Method isMethodWithName: array inClass: [TestClass1],?Source isSourceCodeOfMethod: ?Method,[?Source asString] equals:[(TestClass1>>#array) getSource ] ' description: 'Retrieve the source code of this method'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testIsStatementOfMethod2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: methodWithSend inClass: [TestClassRoot],RBMessageNode(RBMessageNode(RBVariableNode(self),methodWithAssignment,<>),first,<>) isStatementOfMethod: ?Method))'
		description: 'This method has a single statement.'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClassRoot],RBReturnNode(?) isStatementOfMethod: ?Method))'
		description: 'This method has a return statement.'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [SubClass1],?Statement isStatementOfMethod: ?Method))'
		description: 'This method has no statements.'! !

!BasicReasoningTests methodsFor: 'classes' stamp: 'sp 24/10/11 15:26'!
testIsSubclassOf2
	
	self processQuery: ' if succeeds([SubClass1] isSubclassOf: [TestClass1])'
		description: 'Is SubClass1 a subclass of TestClass1?'.
	self processQuery: ' if fails([TestClass1] isSubclassOf: [SubClass1])'
		description: 'Is TestClass1 not a subclass of SubClass1?'.
	self
		processQuery: ' if [SubClass1] isSubclassOf: ?C'
		resultsCheck: [:results | results size = 1]
		description: 'Is SubClass1 the subclass of a unique superclass?'.
	self processQuery:
			' if fails(and([MLI current allRootClassEntities] contains: ?Root,?Root isSubclassOf: ?C))'
		description:
			'Does the predicate subclassOf/2 fail for the rootclasses as subclass?'.
	self processQuery: ' if succeeds(?C isSubclassOf: [TestClass1])'
		description: 'Does TestClass1 have at least one subclass?'.
	self processQuery: ' if succeeds(one(?C isSubclassOf: ?S))' description:
			'Can the predicate subclassOf/2 be used with two arguments unbound?'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testIsTemporaryVariableOfMethod2
	
	self processQuery:
			' if fails(and(?Method isMethodWithName: method4 inClass: [TestClass1],?V isTemporaryVariableOfMethod: ?Method))'
		description: 'This method has no temporary variables'.
	self
		processQuery:
			' if ?Method isMethodWithName: commentedMethod3 inClass: [TestClass5],?V isTemporaryVariableOfMethod: ?Method'
		resultsCheck: [:result | result size = 2]
		description: 'This method has two temporary variables'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodAccessesInstanceVariableInClass3
	
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodAccessesInstanceVariable: newString inClass: ?Class))'
		description:
			'This method assigns to the local variable newString; not to an instance variable'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: [#array:] inClass: [TestClass1],?Method methodAccessesInstanceVariable: array inClass: ?Class))'
		description: 'This method assigns to the instance variable array'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: [#array] inClass: [TestClass1],?Method methodAccessesInstanceVariable: array inClass: [TestClass1]))'
		description: 'This method reads the instance variable array'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodAssignsInstanceVariableInClass3
	
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodAssignsInstanceVariable: newString inClass: ?Class))'
		description:
			'This method assigns to the local variable newString; not to an instance variable'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [SubClass1],?Method methodAssignsInstanceVariable: newString inClass: ?Class))'
		description: 'This method does not do any assignments'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: [#array:] inClass: [TestClass1],?Method methodAssignsInstanceVariable: array inClass: ?Class))'
		description: 'This method assigns to the instance variable array'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodAssignsVariableExpression3
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodAssignsVariable: newString expression: RBMessageNode(RBVariableNode(self),copy,<>)))'
		description: 'This method assigns to the local variable newString'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [SubClass1],?Method methodAssignsVariable: ? expression: ?))'
		description: 'This method does not do any assignments'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: [#array:] inClass: [TestClass1],?Method methodAssignsVariable: array expression: RBVariableNode(anArray)))'
		description: 'This method assigns to the instance variable array'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodCallsMethod2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: methodWithSend inClass: [TestClassRoot],?Method methodCallsMethod: ?M2,?M2 isMethodWithName: methodWithAssignment,!!))'
		description:
			'Verify that this method calls a method named methodWithAssignment'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: methodWithSend inClass: [TestClassRoot],?M isMethodWithName: methodWithAssignment inClass: [TestClassRoot],?Method methodCallsMethod: ?M2))'
		description:
			'Verify that this method calls a method named methodWithAssignment'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testMethodOverridesMethod2
	
	self processQuery:
			' if succeeds(and(?m1 isMethodWithName: foo inClass: [TestClass4],?m2 isMethodWithName: foo inClass: [TestClassRoot],?m1 methodOverridesMethod: ?m2))'
		description: 'Both arguments bound; success'.
	self processQuery:
			' if succeeds(and(?m1 isMethodWithName: foo inClass: [SubClass1],?m2 isMethodWithName: foo inClass: [TestClassRoot],?m1 methodOverridesMethod: ?m2))'
		description: 'Both arguments bound; indirect inheritance; success'.
	self processQuery:
			' if fails(and(?m1 isMethodWithName: foo inClass: [TestClass4],?m2 isMethodWithName: foo inClass: [TestClassRoot],?m2 methodOverridesMethod: ?m1))'
		description: 'Both arguments bound; failure'.
	self processQuery:
			' if succeeds(and(?m1 isMethodWithName: foo inClass: [TestClass4],?m1 methodOverridesMethod: ?m2,?m2 isMethodWithName: foo inClass: [TestClassRoot]))'
		description: 'First argument bound; success'.
	self processQuery:
			' if succeeds(and(?m2 isMethodWithName: foo inClass: [TestClassRoot],?m1 methodOverridesMethod: ?m2,?m1 isMethodWithName: foo inClass: [TestClass4]))'
		description: 'Second argument bound; success'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodReadsInstanceVariableInClass3
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: [#array] inClass: [TestClass1],?Method methodReadsInstanceVariable: array inClass: [TestClass1]))'
		description: 'This method reads the instance variable array'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: [#sumWith:] inClass: [TestClass1],?Method methodReadsInstanceVariable: anInteger inClass: [TestClass1]))'
		description: 'anInteger is an argument'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: [#withShadowing] inClass: [TestClass1],?Method methodReadsInstanceVariable: array inClass: [TestClass1]))'
		description: 'array is shadowed'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: [#array:] inClass: [TestClass1],?Method methodReadsInstanceVariable: array inClass: [TestClass1]))'
		description: 'array is written to; not read'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodReferencesClass2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClass4],?Method methodReferencesClass: [Array]))'
		description: 'Verify that this method refers to the class Array.'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: fooFullReference inClass: [TestClass4],?Method methodReferencesClass: [Array]))'
		description:
			'Verify that this method refers to the class Array (now with full reference).'.
	self processQuery:
			' if ?Method isMethodWithName: bar inClass: [TestClass4],fails(?Method methodReferencesClass: [Array])'
		description: 'Verify that this method does not refer to the class Array.'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: bar inClass: [TestClass4],?Method methodReferencesClass: [Set]))'
		description: 'Verify that this method refers to the class Set.'.
	self
		processQuery:
			' if ?Method isMethodWithName: zork inClass: [TestClass4],?Method methodReferencesClass: ?Class'
		resultsCheck: [:results | results size = 3]
		description: 'Verify that this method refers to 3 classes.'.
	self processQuery:
			' if fails(and(?method isMethodWithName: method6 inClass: [TestClass5],?method methodReferencesClass: ?class))'
		description:
			'Verify that TestClass1>>method6 does not reference any class, even though it uses the global variable ThisIsAGlobalVariableThatDoesNotReferenceAClass'.
	self processQuery: ' if fails(foo methodReferencesClass: zork)'
		description:
			'Does the methodReferencesClass predicate handles bad information gracefully?'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodReturnsBoolean2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: isNode inClass: [Node],?Method methodReturnsBoolean: [true]))'
		description: 'This method return true'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: isNode inClass: [Tree],?Method methodReturnsBoolean: [false]))'
		description: 'This method return false'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodReturnsBoolean: ?))'
		description: 'This method returns a complex statement'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [SubClass1],?Method methodReturnsBoolean: ?))'
		description: 'This method does not return anything'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodReturnsExpression2
	
	self processQuery:
			' if fails(and(?Method isMethodWithName: methodWithSend inClass: [TestClassRoot],?Method methodReturnsExpression: ?Exp))'
		description: 'This method has a single non-return, statement.'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodReturnsExpression: ?Exp))'
		description: 'This method has a return statement.'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [SubClass1],?Method methodReturnsExpression: ?Exp))'
		description: 'This method has no statements.'.
	self
		processQuery:
			' if ?Method isMethodWithName: [#complexWith:and:and:and:] inClass: [TestClassRoot],?Method methodReturnsExpression: ?Exp'
		resultsCheck: [:result | result size = 5]
		description: 'This method has multiple returns.'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodSendsSelector2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodSendsSelector: zork))'
		description: 'Verify that this method sends message #zork'.
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodSendsSelector: copy))'
		description: 'Verify that this method sends message #copy'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodSendsSelector: HIGHLYUNLIKELY))'
		description:
			'Verify that this method does not send message #HIGHLYUNLIKELY'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: methodWithSimpleReturn inClass: [TestClassRoot],?Method methodSendsSelector: ?s))'
		description: 'Verify that this method does not send any messages'! !

!BasicReasoningTests methodsFor: 'method body' stamp: 'sp 24/10/11 15:26'!
testMethodWithUniqueStatement2
	
	self processQuery:
			' if succeeds(and(?Method isMethodWithName: methodWithSend inClass: [TestClassRoot],?Method methodWithUniqueStatement: RBMessageNode(RBMessageNode(RBVariableNode(self),methodWithAssignment,<>),first,<>)))'
		description: 'This method has a single statement.'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [TestClassRoot],?Method methodWithUniqueStatement: ?Statement))'
		description: 'This method has multiple statements'.
	self processQuery:
			' if fails(and(?Method isMethodWithName: foo inClass: [SubClass1],?Method methodWithUniqueStatement: ?Statement))'
		description: 'This method has no statements.'! !

!BasicReasoningTests methodsFor: 'methods' stamp: 'sp 24/10/11 15:26'!
testisAbstractMethodInClass2
	
	self processQuery:
			' if succeeds(and(?method isAbstractMethodInClass: [TestClass3],?method isMethodWithName: anAbstractMethod))'
		description:
			'checks whether Soul.TestClass3>>anAbstractMethod is an abstract method'.
	self processQuery:
			' if succeeds(and(?method isAbstractMethodInClass: [TestClass3],?method isMethodWithName: anotherAbstractMethod))'
		description:
			'checks whether Soul.TestClass3>>anotherAbstractMethod is an abstract method'! !

LogicTests subclass: #PackagingReificationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!PackagingReificationTests commentStamp: '<historical>' prior: 0!
self suite run!

!PackagingReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsClassCategory1
	
	self processQuery: ' if succeeds(?Category isClassCategory)' description:
			'Can the predicate be used to extract categories?'.
	self processQuery: ' if succeeds([#''Kernel-Objects''] isClassCategory)'
		description: 'Is Kernel-Objects an existing class category?'! !

!PackagingReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsClassInCategory2
	
	self processQuery:
			' if ?category isClassCategory,[?category = #''LiCoR-Tests''],?class isClassInCategory: ?category'
		description: 'We can extract classes from a category'.
	self processQuery:
			' if ?class isClass,[?class name asString = ''PackagingReificationTests''],?class isClassInCategory: ?category,[?category = #''LiCoR-Tests'']'
		description: 'We can extract the category from a class'! !

!PackagingReificationTests methodsFor: 'binary relations' stamp: 'AndyKellens 10/25/2011 13:43'!
testIsClassInPackage2
	
	self
		processQuery:
			' if ?class isClassInPackage: [''LiCoR-Tests'']'
		resultsCheck:
			[:results | 
			(Smalltalk allClasses select:[:each | each category = 'LiCoR-Tests']) size = results size]
		description: 'Can we get all the classes defined in a given package?'.	"First we get a random package (for example the first one we encounter). Then we take a random Smalltalk class
	 that does NOT belong to this package and we check that classInPackage/2 indeed fails."

	self processQuery:
			' if succeeds([PackagingReificationTests] isClassInPackage: [''LiCoR-Tests''])'
		description: 'Can we test the package for a class?'.
	self processQuery:
			' if succeeds(and([PackagingReificationTests] isClassInPackage: ?P,[?P = ''LiCoR-Tests'']))'
		description: 'Can we get the package for a class?'.
	self processQuery:
			' if succeeds(and([PackagingReificationTests class] isClassInPackage: ?P,[?P = ''LiCoR-Tests'']))'
		description:
			'Can we get the package for a metaclass using classInPackage/2?'.
	self processQuery:
			' if succeeds(and(?P isPackage,[?P = ''LiCoR-Tests''],[PackagingReificationTests class] isClassInPackage: ?P))'
		description:
			'Can we get the package for a metaclass using isClassInPackage:/2?'.
	self
		processQuery: ' if [Object] isClassInPackage: ?P'
		resultsCheck: [:results | results size = 1]
		description:
			'Does the isClassInPackage:/2 predicate only returns the package where the class is defined (and not where it is extended)?)'.
	self processQuery: ' if fails([1] isClassInPackage: [#succeeds])'
		description:
			'Does the predicate fail when not passed classes or packages'! !

!PackagingReificationTests methodsFor: 'entities' stamp: 'AndyKellens 10/25/2011 13:46'!
testIsPackage1
	
	self processQuery: ' if succeeds([Smalltalk organization categories first] isPackage)'
		description: 'Can we check for an existing package?'.
	self
		processQuery: ' if ?package isPackage'
		resultsCheck: [:results | results size = Smalltalk organization categories size]
		description: 'Can we enumerate all packages?'.
	self processQuery: ' if fails([''Soul''] isPackage)' description:
			'Does package fail for the string ''Soul''?'! !

!PackagingReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsProtocol1
	
	self processQuery: ' if succeeds(?Protocol isProtocol)' description:
			'Can the predicate be used to extract protocols?'.
	self processQuery: ' if succeeds([#accessing] isProtocol)' description:
			'Is accessing an existing method protocol?'! !

!PackagingReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsProtocolInClass2
	
	self processQuery:
			' if succeeds(and(?Protocol isProtocolInClass: ?Class,nonvar(?Protocol),nonvar(?Class)))'
		description:
			'Can the predicate isProtocolInClass:/2 be used to find all protocols of all classes?'.
	self processQuery:
			' if succeeds(and(?Protocol isProtocolInClass: ?Class,?Protocol isProtocol,?Class isClass))'
		description:
			'Is the result produced by the predicate isProtocolInClass:/2 of the expected type?'.
	self processQuery:
			' if succeeds([#protocol1] isProtocolInClass: [TestClass1])'
		description:
			'Can the predicate isProtocolInClass:/2 be used to check that a given protocol belongs to a given class?'.
	self processQuery: ' if succeeds([#protocol1] isProtocolInClass: ?Class)'
		description:
			'Can the predicate isProtocolInClass:/2 be used to find all classes with a given protocol?'.
	self
		processQuery: ' if ?protocol isProtocolInClass: [TestClass1]'
		resultsCheck: [:results | results size = 3]
		description: 'Can we ask for the protocols that are in a class?'.
	self processQuery: ' if fails(?protocol isProtocolInClass: foo)'
		description:
			'Does this predicate fail when given the wrong kind of parameters?'.
	self processQuery: ' if fails(foo isProtocolInClass: ?class)' description:
			'Does this predicate fail when given the wrong kind of parameters?'.
	self processQuery: ' if fails(foo isProtocolInClass: foo)' description:
			'Does this predicate fail when given the wrong kind of parameters?'! !

LogicTests subclass: #SmalltalkReificationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!SmalltalkReificationTests commentStamp: '<historical>' prior: 0!
self suite run
!

!SmalltalkReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsBaseClass1
	
	self
		processQuery: ' if ?c isBaseClass'
		resultsCheck:
			[:results | results size = MLI current allBaseClassEntities size]
		description:
			'Is the number of returned base classes equal to what is expected?'.
	self processQuery: ' if succeeds([TestClass1] isBaseClass)' description:
			'Is TestClass1 a base class?'.
	self processQuery: ' if fails([Foo] isBaseClass)' description:
			'Is Foo a non-existing base class?'.
	self processQuery: ' if fails(1 isBaseClass)' description:
			'Does baseClass/1 fail for an expression that is not a base class?'.
	self processQuery: ' if fails([TestClass1 class] isBaseClass)'
		description: 'Is the meta class of TestClass1 NOT a base class?'.
	self processQuery:
			' if succeeds(and(member(?C,[TestClassRoot allSubclasses]),forall(?C isBaseClass,not(?C isMetaClass))))'
		description:
			'Is no base class a meta class? (restricted to TestClassRoot hierarchy for performance reasons)'.
	self processQuery:
			' if succeeds(and(member(?C,[TestClassRoot allSubclasses]),forall(?C isBaseClass,?C isClass)))'
		description:
			'Is every base class a class? (restricted to TestClassRoot hierarchy for performance reasons)'! !

!SmalltalkReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsClass1
	
	self processQuery: ' if succeeds([TestClass1] isClass)' description:
			'Is TestClass1 a class?'.
	self processQuery: ' if fails([Foo] isClass)' description:
			'Is Foo NOT a class?'.
	self processQuery: ' if fails(1 isClass)' description:
			'Does isClass fail on an expression that is not a class?'.
	self processQuery: ' if succeeds([TestClass1 class] isClass)' description:
			'Is the meta class of TestClass1 a class?'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsClassMethodInClass2
	
	self
		processQuery:
			' if ?method isClassMethodInClass: [TestClass1],?method isMethod'
		resultsCheck: [:results | results size = 2]
		description:
			'Can we extract all class methods from a class and are they all methods?'.
	self processQuery:
			' if ?m isMethod,?m isClassMethodInClass: ?class,!!,equals([?m fromClass],[?class class])'
		description: 'Can we extract the class from a class method?'.
	self processQuery: ' if succeeds(?method isClassMethodInClass: ?class)'
		description: 'Can we extract classMethodInClass relations?'.
	self processQuery:
			' if fails(and(?method isClassMethodInClass: [TestClass1],?method isClassMethodInClass: [AbstractTerm]))'
		description: 'Can we check if a method is not in class'.
	self processQuery:
			' if fails(and(foo isClassMethodInClass: ?class,?method isClassMethodInClass: foo,foo isClassMethodInClass: foo))'
		description:
			'Does methodInClass fail when given something else than a method or a class?'.
	self processQuery:
			' if ?method1 isMethod,?method1 isClassMethodInClass: ?class,!!,findall(?method2,?method2 isClassMethodInClass: ?class,?list),member(?method1,?list)'
		description:
			'Basic sanity test for classMethodInClass: all solutions when ?method is bound should also be solutions when ?method is unbound.'! !

!SmalltalkReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsClassVariable1
	
	self processQuery: ' if fails([#fooujhqdghjqdvsb] isClassVariable)'
		description: 'Does no class variable with this name exist?'.
	self processQuery: ' if succeeds(?V isClassVariable)' description:
			'Can the predicate be used to extract instance variable names?'.
	self processQuery: ' if succeeds(one([#mcivar1] isClassVariable))'
		description: 'Does a class variable with this name exist?'.
	self processQuery: ' if fails([#iv1] isClassVariable)' description:
			'Is iv1 not a class variable? (It is an instance variable.)'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsClassVariableInClass2
	
	self processQuery: ' if fails(?IV isClassVariableInClass: [TestClass3])'
		description: 'Does TestClass3 have class variables => no?'.
	self processQuery:
			' if succeeds(?IV isClassVariableInClass: [TestClass1])' description:
			'Does TestClass1 have at least one instance variable?'.
	self processQuery:
			' if succeeds([#mcivar1] isClassVariableInClass: [TestClass1])'
		description: 'Does TestClass1 have an class variable named mcivar1?'.
	self processQuery:
			' if fails([#fooujhqdghjqdvsb] isClassVariableInClass: [TestClass1])'
		description:
			'Does TestClass1 have no class variable with this absurd name?'.
	self processQuery:
			' if succeeds([#mcivar1] isInstanceVariableInClass: ?C)' description:
			'Are there classes with class variable named mcivar1?'.
	self processQuery: ' if succeeds(?IV isClassVariableInClass: ?C)'
		description:
			'Can we use the predicate isClassVariableInClass/2 with two arguments unbound?'.
	self processQuery: ' if fails(1 isClassVariableInClass: [TestClass1])'
		description:
			'Does the predicate isClassVariableInClass/2 fail when a number is provided as variable name?'.
	self processQuery: ' if fails([#iv1] isClassVariableInClass: 1)'
		description:
			'Does the predicate isClassVariableInClass/2 fail when a number is provided as class name?'! !

!SmalltalkReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsInstanceVariable1
	
	self processQuery: ' if succeeds([#iv1] isInstanceVariable)' description:
			'Does an instance variable with this name exist?'.
	self processQuery: ' if fails([#fooujhqdghjqdvsb] isInstanceVariable)'
		description: 'Does no instance variable with this name exist?'.
	self processQuery: ' if succeeds(one(?IV isInstanceVariable))'
		description:
			'Can the predicate be used to extract instance variable names?'.
	self processQuery: ' if fails([#mcivar1] isInstanceVariable)' description:
			'Is mcivar1 not an instance variable? (It is a class variable.)'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsInstanceVariableInClass2
	
	self processQuery:
			' if fails(?IV isInstanceVariableInClass: [TestClass3])' description:
			'Does TestClass3 have no instance variables?'.
	self processQuery:
			' if succeeds(?IV isInstanceVariableInClass: [TestClass1])' description:
			'Does TestClass1 have at least one instance variable?'.
	self processQuery:
			' if succeeds([#iv1] isInstanceVariableInClass: [TestClass1])'
		description: 'Does TestClass1 have an instance variable named iv1?'.
	self processQuery:
			' if fails([#fooujhqdghjqdvsb] isInstanceVariableInClass: [TestClass1])'
		description:
			'Does TestClass1 have no instance variable with this absurd name?'.
	self processQuery: ' if succeeds([#iv1] isInstanceVariableInClass: ?C)'
		description:
			'Can we use the predicate instanceVariableInClass/2 to extract classes with a give instance variable name?'.
	self processQuery: ' if succeeds(?IV isInstanceVariableInClass: ?C)'
		description:
			'Can we use the predicate instanceVariableInClass/2 with two arguments unbound?'.
	self processQuery: ' if fails(1 isInstanceVariableInClass: [TestClass1])'
		description:
			'Does the predicate instanceVariableInClass/2 fail when a number is provided as variable name?'.
	self processQuery: ' if fails([#iv1] isInstanceVariableInClass: 1)'
		description:
			'Does the predicate instanceVariableInClass/2 fail when a number is provided as class name?'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsInstanceVariableInClassChainOf2
	
	self processQuery:
			' if succeeds(and(?IV isInstanceVariableInClassChainOf: [TestClass1],nonvar(?IV)))'
		description:
			'Does TestClass1 have an instance variable in its class chain? (This is a trivial case as TestClass1 implements instance variables itself.)'.
	self processQuery:
			' if succeeds(and(?IV isInstanceVariableInClassChainOf: [SubClass1],nonvar(?IV)))'
		description:
			'Does SubClass1, which does not declare any instance variables itself, indirectly has an instance variable?'.
	self processQuery:
			' if fails(?IV isInstanceVariableInClassChainOf: [TestClass3])'
		description:
			'Does TestClass3, nor any of its superclasses declare instance variables?'.
	self processQuery:
			' if succeeds([#iv2] isInstanceVariableInClassChainOf: [TestClass1])'
		description:
			'Does TestClass1 have the instance variable iv2 in its class chain? (This is a trivial case as TestClass1 implements the instance variable itself.)'.
	self processQuery:
			' if succeeds([#iv2] isInstanceVariableInClassChainOf: [SubClass2])'
		description:
			'Does SubClass2, which does not declare any instance variables itself, indirectly has an instance variable iv2?'.
	self processQuery:
			' if fails([#fooujhqdghjqdvsb] isInstanceVariableInClassChainOf: [SubClass2])'
		description:
			'Does Subclass2 have no (direct or indirect) instance variable fooujhqdghjqdvsb?'.
	self processQuery:
			' if succeeds(and([#array] isInstanceVariableInClassChainOf: ?C,nonvar(?C)))'
		description:
			'Can we use the predicate to extract classes that (directly or indirectly) have a given instance variable name?'.
	self processQuery:
			' if succeeds(and([#iv2] isInstanceVariableInClassChainOf: ?C,nonvar(?C),equals(?C,[TestClass1])))'
		description:
			'When using instanceVariableInClassChain/2 with the class unbound, does it return the class that (directly) declares the instance variable?'.
	self processQuery:
			' if succeeds(and([#iv2] isInstanceVariableInClassChainOf: ?C,nonvar(?C),equals(?C,[SubClass2])))'
		description:
			'When using instanceVariableInClassChain/2 with the class unbound, can it return a classes that indirectly has the instance variable?'.
	self processQuery:
			' if succeeds(and(?IV isInstanceVariableInClassChainOf: ?C,nonvar(?IV),nonvar(?C)))'
		description: 'Can we use the predicate with two arguments unbound?'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsInstanceVariableInMetaClass2
	
	self processQuery:
			' if succeeds(one(and(?V isInstanceVariableInMetaClass: ?C,nonvar(?V),nonvar(?C))))'
		description:
			'Does isInstanceVariable:InMetaClass:/2 work with two variables?'.
	self processQuery:
			' if succeeds(and(?V isInstanceVariableInMetaClass: [TestClass1 class],nonvar(?V)))'
		description:
			'Does the meta class of TestClass1 have at least one instance variable?'.
	self processQuery:
			' if fails(?V isInstanceVariableInMetaClass: [TestClass3 class])'
		description:
			'Does the meta class of TestClass3 have no instance variables?'.
	self processQuery:
			' if succeeds([#mcivar1] isInstanceVariableInMetaClass: [TestClass1 class])'
		description:
			'Does the meta class of TestClass1 have an instance variable mcivar1?'.
	self processQuery:
			' if succeeds(and([#mcivar1] isInstanceVariableInMetaClass: ?C,nonvar(?C)))'
		description:
			'Can we find a class of which the meta class has an instance variable named mcivar1?'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsInstanceVariableInMetaClassChainOf2
	"self run: #testinstanceVariableInMetaClassChain2"

	
	self processQuery:
			' if succeeds(one(and(?V isInstanceVariableInMetaClassChainOf: ?C,nonvar(?V),nonvar(?C))))'
		description: 'Can we find solutions?'.
	self processQuery:
			' if succeeds(and(?V isInstanceVariableInMetaClassChainOf: [SubClass1 class],nonvar(?V)))'
		description:
			'Does the meta class of SubClass1 have at least one instance variable (either directly or indirectly)?'.
	self processQuery:
			' if succeeds([#mcivar1] isInstanceVariableInMetaClassChainOf: [TestClass1 class])'
		description:
			'Does the meta class of TestClass1 have an instance variable mcivar1 (either directly or indirectly)? (This is the trivial case because the meta class of TestClass1 itself declares the instance variable.'.
	self processQuery:
			' if succeeds([#mcivar1] isInstanceVariableInMetaClassChainOf: [SubClass1 class])'
		description:
			'Does the meta class of SubClass1, which does not declare any instance variables, indirectly have an instance variable mcivar1?'.
	self processQuery:
			' if succeeds(and([#mcivar1] isInstanceVariableInMetaClassChainOf: ?C,nonvar(?C)))'
		description:
			'Can we find a class of which the meta class has an instance variable mcivar1 (either directly or indirectly)?'.
	self processQuery:
			' if succeeds(and([#mcivar1] isInstanceVariableInMetaClassChainOf: ?C,nonvar(?C),?C equals: [TestClass1 class]))'
		description:
			'Can we find a class of which the meta class (directlty or indirectly) has an instance variable mcivar1 (either directly or indirectly), and is TestClass1 one of the returned results?'.
	self processQuery:
			' if succeeds(and([#mcivar1] isInstanceVariableInMetaClassChainOf: ?C,nonvar(?C),?C equals: [SubClass1 class]))'
		description:
			'Can we find a class of which the meta class (directlty or indirectly) has an instance variable mcivar1 (either directly or indirectly), and is SubClass1 one of the returned results?'! !

!SmalltalkReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsMetaClass1
	
	self
		processQuery: ' if ?C isMetaClass'
		resultsCheck:
			[:results | results size = MLI current allMetaClassEntities size]
		description: 'There are as many meta classes as expected'.
	self processQuery: ' if succeeds([TestClass1 class] isMetaClass)'
		description: 'Is <Soul.SoulTests.TestClass1 class> a meta class?'.
	self processQuery: ' if fails([TestClass1] isMetaClass)' description:
			'Is Soul.SoulTests.TestClass1 NOT a meta class?'.
	self processQuery: ' if fails(1 isMetaClass)' description:
			'Is a number NOT a meta class?'.
	self processQuery:
			' if succeeds(and(member(?C,[TestClassRoot allSubclasses]),equals(?MC,[?C class]),forall(?MC isMetaClass,not(?MC isBaseClass))))'
		description:
			'Is no meta class a base class? (restricted to the hierarchy of TestClassRoot for performance reasons)'.
	self processQuery:
			' if succeeds(and(member(?C,[TestClassRoot allSubclasses]),equals(?MC,[?C class]),forall(?MC isMetaClass,?MC isClass)))'
		description:
			'Is every meta class a class? (restricted to the hierarchy of TestClassRoot for performance reasons)'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsMetaClassOf2
	
	self processQuery:
			' if succeeds([TestClass1 class] isMetaClassOf: [TestClass1])'
		description:
			'Is <Soul.SoulTests.TestClass1 class> the meta class of Soul.SoulTests.TestClass1?'.
	self processQuery:
			' if succeeds([TestClass1 class class] isMetaClassOf: [TestClass1 class])'
		description:
			'Is <Soul.SoulTests.TestClass1 class class> the meta class of Soul.SoulTests.TestClass1 class?'.
	self processQuery:
			' if succeeds(forall([TestClass1 class] isMetaClassOf: ?C,equals(?C,[TestClass1])))'
		description:
			'Is <Soul.SoulTests.TestClass1 class> the only meta class of Soul.SoulTests.TestClass1?'.
	self processQuery:
			' if succeeds(forall(?M isMetaClassOf: [TestClass1],equals(?M,[TestClass1 class])))'
		description:
			'Is Collection the only base class of <Soul.SoulTests.TestClass1 class>?'! !

!SmalltalkReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsMethod1
	
	self
		processQuery: ' if ?M isMethod'
		resultsCheck:
			[:results | 
			| mResults |
			mResults := results resultsForVariableNamed: 'M'.
			(mResults
				contains:
					[:sm | 
					sm smalltalkValue fromClass = TestClassRoot
						and: [sm smalltalkValue selector = #doNotOverride]])
				and:
					[mResults
						contains:
							[:sm | 
							sm smalltalkValue fromClass = TestClassRoot class
								and: [sm smalltalkValue selector = #aClassMethod]]]]
		description:
			'Can we find that Soul.TestClassRoot>>#doNotOverride and Soul.TestClassRoot class>>#aClassMethod belong to all methods?'.
	self processQuery: ' if one(?m isMethod),?m isMethod' description:
			'Is each method we can get from the method predicate really a method?'.
	self processQuery:
			' if [(MLI current methodsInClass: TestClassRoot)
	detect: [:m | m selector = #doNotOverride]] isMethod' description:
			'Can we find that Soul.TestClassRoot>>#doNotOverride is indeed a method?'.
	self processQuery:
			' if [(MLI current methodsInClass: TestClassRoot class)
	detect: [:m | m selector = #aClassMethod]] isMethod' description:
			'Can we find that Soul.TestClassRoot class>>#aClassMethod is indeed a method?'.
	self processQuery: ' if fails(foobar isMethod)' description:
			'Are other things not recognized as methods?'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsMethodInClass2
	
	self
		processQuery:
			' if ?method isMethodInClass: [TestClass1],?method isMethod'
		resultsCheck: [:results | results size = 9]
		description:
			'Can we extract all methods from a class and are they all methods?'.
	self processQuery:
			' if one(?m isMethod),?m isMethodInClass: ?class,equals([?m fromClass],?class)'
		description: 'Can we extract the class from a method?'.
	self processQuery:
			' if one(?m isMethod),equals([?m fromClass],?class),?m isMethodInClass: ?class'
		description: 'Can we check a methodInClass relation?'.
	self processQuery: ' if succeeds(?method isMethodInClass: ?class)'
		description: 'Can we extract methodInClass relations?'.
	self processQuery:
			' if fails(and(?method isMethodInClass: [TestClass1],?method isMethodInClass: [AbstractTerm]))'
		description: 'Can we check if a method is not in class'.
	self processQuery:
			' if fails(and(foo isMethodInClass: ?class,?method isMethodInClass: foo,foo isMethodInClass: foo))'
		description:
			'Does methodInClass fail when given something else than a method or a class?'.
	self processQuery:
			' if one(?method1 isMethod),?method1 isMethodInClass: ?class,findall(?method2,?method2 isMethodInClass: ?class,?list),member(?method1,?list)'
		description:
			'Basic sanity test for methodInClass: all solutions when ?method is bound should also be solutions when ?method is unbound.'! !

!SmalltalkReificationTests methodsFor: 'method attributes' stamp: 'sp 24/10/11 15:26'!
testIsParseTreeOfMethod2
	
	self processQuery: ' if succeeds(one(?tree isParseTreeOfMethod: ?method))'
		description: 'We do find a parse tree of a method'.
	self processQuery:
			' if equals(?method,[(MLI current methodsInClass: TestClassRoot)
	detect: [:m | m selector = #doNotOverride]]),?tree isParseTreeOfMethod: ?method,succeeds([?tree isKindOf: RBMethodNode])'
		description: 'Can we find the parse tree of TestClassRoot>>doNotOverride'! !

!SmalltalkReificationTests methodsFor: 'entities' stamp: 'sp 24/10/11 15:26'!
testIsRootClass1
	
	self processQuery: ' if succeeds(?X isRootClass)' description:
			'Is there at least one root class?'.
	self processQuery: ' if fails([TestClass1] isRootClass)' description:
			'isRootClass is supposed to fail on a non rootclass'! !

!SmalltalkReificationTests methodsFor: 'method attributes' stamp: 'AndyKellens 10/25/2011 13:53'!
testIsSourceCodeOfMethod2
	
	self processQuery:
			' if succeeds(one(?code isSourceCodeOfMethod: ?method))' description:
			'We do find the source code of a method'.
	self processQuery:
			' if equals(?method,[(MLI current methodsInClass: TestClassRoot)
	detect: [:m | m selector = #doNotOverride]]),?code isSourceCodeOfMethod: ?method,succeeds([?code asString =
		(TestClassRoot>>#doNotOverride) getSource ])' description:
			'Can we find the source code of TestClassRoot>>doNotOverride'! !

!SmalltalkReificationTests methodsFor: 'binary relations' stamp: 'sp 24/10/11 15:26'!
testIsSuperclassOf2
	
	self processQuery:
			' if succeeds([TestClass1] isSuperclassOf: [SubClass1])' description:
			'Is TestClass1 the superclass of SubClass1?'.
	self processQuery: ' if fails([SubClass1] isSuperclassOf: [TestClass1])'
		description: 'Is SubClass1 not the superclass of TestClass1?'.
	self
		processQuery: ' if ?C isSuperclassOf: [SubClass1]'
		resultsCheck: [:results | results size = 1]
		description: 'Does SubClass1 have a unique superclass?'.
	self processQuery: ' if succeeds([TestClass1] isSuperclassOf: ?C)'
		description: 'Does TestClass1 have at least one subclass?'.
	self processQuery: ' if succeeds(?S isSuperclassOf: ?C)' description:
			'Can the predicate be used with two arguments unbound?'! !

!SmalltalkReificationTests methodsFor: 'method attributes' stamp: 'sp 24/10/11 15:26'!
testMethodContainsSourceComment2
	
	self processQuery:
			' if ?method isMethodInClass: [TestClass5],[?method selector = #commentedMethod3],?method methodContainsSourceComment: [''Smalltalk'']'
		description:
			'The method TestClass5>>commentedMethod3 has a comment "Smalltalk"'.
	self processQuery:
			' if ?method isMethodInClass: [TestClass5],[?method selector = #commentedMethod3],?method methodContainsSourceComment: [''Smalltalk''],?method methodContainsSourceComment: [''is''],?method methodContainsSourceComment: [''fun'']'
		description:
			'The method TestClass5>>commentedMethod3 has the three comments "Smalltalk", "is" and "fun" '.
	self processQuery:
			' if ?method isMethodInClass: [TestClass5],[?method selector = #commentedMethod3],not(?method methodContainsSourceComment: [''Java''])'
		description:
			'The method TestClass5>>commentedMethod3 does not have a comment "Java"'.
	self processQuery:
			' if ?method isMethodInClass: [TestClass5],[?method selector = #commentedMethod0],not(?method methodContainsSourceComment: ?comment)'
		description: 'The method TestClass5>>commentedMethod0 has no comments.'! !

!SmalltalkReificationTests methodsFor: 'method attributes' stamp: 'sp 24/10/11 15:26'!
testMethodHasAnnotationWithValues3
	
	self processQuery:
			' if ?method isMethodInClass: [TestClassWithAttributedMethod],[?method selector = #method1],?method methodHasAnnotation: #test: withValues: <itsatest>'
		description:
			'The method TestClassWithAttributedMethod>>method1 has an attribute test with value #itsatest'.
	self processQuery:
			' if ?method isMethodInClass: [TestClassWithAttributedMethod],?method methodHasAnnotation: #test: withValues: <itsatest>,[?method selector = #method1]'
		description:
			'One of the methods with attribute test with value #itsatest is the method TestClassWithAttributedMethod>>method1 (tests leaving the ?method argument unbound)'.
	self processQuery:
			' if ?method isMethodInClass: [TestClassWithAttributedMethod],[?method selector = #method1],not(?method methodHasAnnotation: ?key withValues: ?values,not(equals(?key,#test:)),not(equals(?values,<itsatest>)))'
		description:
			'The method TestClassWithAttributedMethod>>method1 doesnt have any attributes whose key is not #test or whose value is not #itsatest'.
	self processQuery:
			' if ?method isMethodInClass: [TestClassWithAttributedMethod],[?method selector = #method2],?method methodHasAnnotation: #symbol: withValues: <asymbol>'
		description:
			'The method TestClassWithAttributedMethod>>method2 has an attribute symbol -> #asymbol.'.
	self processQuery:
			' if ?method isMethodInClass: [TestClassWithAttributedMethod],[?method selector = #method2],?method methodHasAnnotation: ?key withValues: <[''A String'']>'
		description:
			'The method TestClassWithAttributedMethod>>method2 has an attribute with value ''A String'' '.
	self processQuery:
			' if ?method isMethodInClass: [TestClassWithAttributedMethod],[?method selector = #method2],?method methodHasAnnotation: #x:y: withValues: <1,2>'
		description:
			'The method TestClassWithAttributedMethod>>method2 has an attribute key x:y: and values 1 and 2'.
	self processQuery:
			' if ?method isMethodInClass: [TestClassWithAttributedMethod],[?method selector = #method2],?method methodHasAnnotation: ?key withValues: <[#(1 #a ''test'')]>'
		description:
			'The method TestClassWithAttributedMethod>>method2 has an attribute with value #(1 a ''test'').'! !

LogicTests subclass: #TemplateQueriesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!TemplateQueriesTest methodsFor: 'Private' stamp: 'AndyKellens 3/20/2012 15:07'!
repository
	
	^SoulFactory repository:#'LiCoR-Smalltalk'! !

!TemplateQueriesTest methodsFor: 'testing template queries' stamp: 'AndyKellens 7/31/2012 10:24'!
testScanner
	self
		processQuery:
			' if scan(stMethod,[''?name ?var := 123. ^true''],?tokens)'
		resultsCheck:
			[:results | 
			(results resultsForVariableNamed: 'tokens') first asString ='<xSoulVariable([#''?name'']),xSoulVariable([#''?var'']),colon([#'':'']),binary([#=]),number([123]),period([#''.'']),upArrow([#''^'']),word([#true])>']
		description: 'Does the scanner return the correct tokens?'
		repository:(SoulFactory repository: #parsing)! !

!TemplateQueriesTest methodsFor: 'testing template queries' stamp: 'AndyKellens 3/20/2012 15:09'!
testTemplateQuery
	self
		processQuery:
			' if ?method isMethodWithName:array inClass:[TestClass1],
			     stMethod(?method) {array ^array}'
		resultsCheck:
			[:results | 
			(results size =  1)]
		description: 'Matching a method'.
	
	self
		processQuery:
			' if ?method isMethodWithName:array inClass:[TestClass1],
			     stMethod(?method) {array ^?var}'
		resultsCheck:
			[:results | 
			(results size =  2)]
		description: 'Matching a method'.
		
	self
		processQuery:
			' if ?method isMethodWithName:array inClass:[TestClass1],
			     stMethod(?method) {?name ^array}'
		resultsCheck:
			[:results | 
			(results size =  1)]
		description: 'Matching a method'.
		
	self
		processQuery:
			' if ?method isMethodWithName:array inClass:[TestClass1],
			     stMethod(?method) {?name ^?name}'
		resultsCheck:
			[:results | 
			(results size =  1)]
		description: 'Matching a method'.! !

!TemplateQueriesTest methodsFor: 'testing template queries' stamp: 'AndyKellens 3/20/2012 15:32'!
testTemplateQuery2
	self
		processQuery:
			' if ?method isMethodWithName: [#method3:] inClass:[TestClass1],
			     stMethod(?method) {method3: arg 
										^self method1
												ifTrue: [arg first]
												ifFalse: [arg asSet]}'
		resultsCheck:
			[:results | 
			(results size =  1)]
		description: 'Matching a method with arguments'.
	
	! !

Object subclass: #TestClassRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

TestClassRoot subclass: #TestClass1
	instanceVariableNames: 'iv1 iv2 array'
	classVariableNames: 'CV1 CV2 Waiting'
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

TestClass1 class
	instanceVariableNames: 'mcivar1'!

!TestClass1 commentStamp: '<historical>' prior: 0!
It is important for the tests that TestClass1 declares the following instance variables:
	array	<SequenceableCollection>
	iv1		<ArithmeticValue | CPointer>
	iv2		<Object>
and that its meta class declares the following instance variables:
	mcivar1	<Object>
Do not change (i.e. remove or rename) any of these variables!!
!

TestClass1 class
	instanceVariableNames: 'mcivar1'!

TestClass1 subclass: #SubClass1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!SubClass1 commentStamp: '<historical>' prior: 0!
It is important for the tests that this class does not implement any instance variables,
nor does its meta class. Do not add any!!!

!SubClass1 methodsFor: 'traversal' stamp: 'sp 24/10/11 15:26'!
foo
	
	! !

TestClass1 subclass: #SubClass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!SubClass2 commentStamp: '<historical>' prior: 0!
It is important for the tests that this class does not implement any instance variables. Do not add any!!

!

!TestClass1 class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
withDefaultName
	
	^self withName: 'Dummy name for testing indirect creation'! !

!TestClass1 class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
withName: aString
	
	^self new name: aString! !

!TestClass1 methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
array
	"An accessor for the instance variable array. Added for the typing tests (#typeByAccessor needs an accessor)"

	
	^array! !

!TestClass1 methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
array: anArray
	"A mutator for the instance variable array. Added for the typing tests (#typeByAssignment needs a mutator)"

	
	array := anArray! !

!TestClass1 methodsFor: 'protocol1' stamp: 'sp 24/10/11 15:26'!
method1
	
	^self method2: 3! !

!TestClass1 methodsFor: 'protocol1' stamp: 'sp 24/10/11 15:26'!
method2: anInteger
	
	^anInteger! !

!TestClass1 methodsFor: 'protocol2' stamp: 'sp 24/10/11 15:26'!
method3: arg
	
	^self method1
		ifTrue: [arg first]
		ifFalse: [arg asSet]! !

!TestClass1 methodsFor: 'protocol2' stamp: 'sp 24/10/11 15:26'!
method4
	"Added for the typing tests. The assigment should be detected when using #typeByExactAssignment. The messages send to array can be used by #typeBySend."

	
	array := Array new.
	array at: 1 put: $a.
	^array first! !

!TestClass1 methodsFor: 'protocol2' stamp: 'sp 24/10/11 15:26'!
method5
	"Added for the typing tests. Uses a mutator to set array to a new instance of SegmentedCollection. Sends messages to the accessor array to test #typeByAccessorSend."

	
	self array: SegmentedCollection new.
	self array at: 1 put: $b.
	^self array first! !

!TestClass1 methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
sumWith: anInteger
	"Just to have some methods that are sent to iv1"

	
	^iv1 + anInteger! !

!TestClass1 methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
withShadowing
	
	| array |
	array := 3.
	^array + 1! !

TestClassRoot subclass: #TestClass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

TestClassRoot subclass: #TestClass3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!TestClass3 commentStamp: '<historical>' prior: 0!
It is important for the tests that this class does not implement any instance variables,
nor does its meta class. Do not add any!!

Subclasses must implement the following messages:
	testing
		anAbstractMethod
		anotherAbstractMethod

!

TestClass3 subclass: #AbstractSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!AbstractSubclass class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
new
	"Answer a newly created and initialized instance."

	
	^super new initialize! !

!AbstractSubclass methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
anAbstractMethod
	" *** This method was defined by Soul.TestClass3 as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	
	self error: 'Subclass responsibility stub not reimplemented'! !

!AbstractSubclass methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
anotherAbstractMethod
	" *** This method was defined by Soul.TestClass3 as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	
	self error: 'Subclass responsibility stub not reimplemented'! !

!AbstractSubclass methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "

	^self! !

TestClass3 subclass: #ConcreteSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!ConcreteSubClass class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
new
	"Answer a newly created and initialized instance."

	
	^super new initialize! !

!ConcreteSubClass methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
anAbstractMethod
	
	! !

!ConcreteSubClass methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
anotherAbstractMethod
	
	! !

!ConcreteSubClass methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
doNotOverride
	
	! !

TestClass3 subclass: #SubClass3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!SubClass3 commentStamp: '<historical>' prior: 0!
It is important for the tests that the meta class of this class does not implement any instance variables. Do not add any!!
!

!TestClass3 methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
aMethod1
	"Do not change the implementation of this method. It is used for testing!!"

	
	self anAbstractMethod! !

!TestClass3 methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
aMethod2
	"Do not change the implementation of this method. It is used for testing!!"

	
	self anotherAbstractMethod! !

!TestClass3 methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
aMethod3
	"Do not change the implementation of this method. It is used for testing!!"

	
	self anUnimplementedMethod! !

!TestClass3 methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
aMethod4
	"Do not change the implementation of this method. It is used for testing!!"

	
	self danglingMethodCall! !

!TestClass3 methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
anAbstractMethod
	"Do not change the implementation of this method. It is used for testing!!"

	
	self subclassResponsibility! !

!TestClass3 methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
anUnimplementedMethod
	"Do not change the implementation of this method. It is used for testing!!"

	
	self shouldNotImplement! !

!TestClass3 methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
anotherAbstractMethod
	"Do not change the implementation of this method. It is used for testing!!"

	
	^self subclassResponsibility! !

TestClassRoot subclass: #TestClass4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!TestClass4 methodsFor: 'methods that reference classes' stamp: 'sp 24/10/11 15:26'!
bar
	
	^Set new! !

!TestClass4 methodsFor: 'methods that reference classes' stamp: 'sp 24/10/11 15:26'!
foo
	
	^Array new! !

!TestClass4 methodsFor: 'methods that reference classes' stamp: 'sp 24/10/11 15:26'!
fooFullReference
	
	^Array new! !

!TestClass4 methodsFor: 'methods that reference classes' stamp: 'sp 24/10/11 15:26'!
zork
	
	^Set new: (OrderedCollection with: Array)! !

TestClassRoot subclass: #TestClass5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!TestClass5 methodsFor: 'commented methods' stamp: 'sp 24/10/11 15:26'!
commentedMethod0
	
	^'This method has no comment'! !

!TestClass5 methodsFor: 'commented methods' stamp: 'sp 24/10/11 15:26'!
commentedMethod1
	"This method has one comment"

	
	^'This method has one comment'! !

!TestClass5 methodsFor: 'commented methods' stamp: 'sp 24/10/11 15:26'!
commentedMethod3
	
	| a "Smalltalk"  b |
	^3 + 4 + 5 + 6 + 7	"is" 	"fun" ! !

!TestClass5 methodsFor: 'protocol3' stamp: 'sp 24/10/11 15:26'!
method6
	
	^ThisIsAGlobalVariableThatDoesNotReferenceAClass new! !

!TestClass5 methodsFor: 'todo methods' stamp: 'sp 24/10/11 15:26'!
todoMethod1
	"TODO: Do not implement anything in this method."

	
	^3! !

!TestClass5 methodsFor: 'todo methods' stamp: 'sp 24/10/11 15:26'!
todoMethod2
	
	self todo: 'Do not implement anything in this method.'.
	^5! !

!TestClass5 methodsFor: 'todo methods' stamp: 'sp 24/10/11 15:26'!
todoMethod3
	"TODO: Do nothing."

	"TODO"

	
	self todo: 'Do nothing more.'! !

!TestClassRoot class methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
aClassMethod
	
	^self new! !

!TestClassRoot methodsFor: 'traversal' stamp: 'sp 24/10/11 15:26'!
complexWith: modifiers and: bindings and: specificImports and: generalImports
	
	| key bind aName |
	aName := 'dummy' , 'concatenation' , $a printString.
	(modifiers hasVisited: self) ifTrue: [^nil].
	key := self asKey: aName.
	bind := bindings lookup: key.
	bind == nil ifFalse: [^bind].
	bind := modifiers substituteFor: self localBindingFor: key.
	bind == nil ifFalse: [^bind].
	1
		to: specificImports size
		do:
			[:imp | 
			bind := (specificImports at: imp) bindingFor: key modifiers: modifiers.
			bind == nil ifFalse: [^bind]].
	bind := nil.
	generalImports size > 0
		ifTrue:
			[modifiers
				forNames: self
				do:
					[1
						to: generalImports size
						do:
							[:imp | 
							| b |
							b := (generalImports at: imp) bindingFor: key modifiers: modifiers.
							b == nil
								ifFalse:
									[(bind == nil or: [bind == b])
										ifTrue: [bind := b]
										ifFalse: [bind := self conflictingImports: key firstFound: bind]]]]].
	^bind! !

!TestClassRoot methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
doNotOverride
	
	self subclassResponsibility! !

!TestClassRoot methodsFor: 'traversal' stamp: 'sp 24/10/11 15:26'!
foo
	
	| newString |
	1
		to: 10
		do: [:each | each halt].
	^self
		compile: (newString := self copy);
		zork! !

!TestClassRoot methodsFor: 'traversal' stamp: 'sp 24/10/11 15:26'!
methodWithAssignment
	
	| temp |
	temp := 1! !

!TestClassRoot methodsFor: 'traversal' stamp: 'sp 24/10/11 15:26'!
methodWithSend
	
	self methodWithAssignment first! !

!TestClassRoot methodsFor: 'traversal' stamp: 'sp 24/10/11 15:26'!
methodWithSimpleReturn
	
	^1! !

!TestClassRoot methodsFor: 'traversal' stamp: 'sp 24/10/11 15:26'!
otherComplexWith: aString
	
	| compiler method mclass env newString |
	compiler := self compilerClass new.
	self namedReferent isBehavior
		ifTrue:
			[mclass := self namedReferent.
			env := mclass environment]
		ifFalse:
			[mclass := nil class.
			env := self namedReferent].
	method := compiler
		methodClass: compiler methodClassForInitializers;
		allowClassVariableReferences: mclass == self namedReferent;
		compile: (newString := aString copy)
			in: nil
			allowReceiver: false
			class: mclass
			environment: env
			noPattern: true
			notifying: nil
			ifFail: [self error: 'Can''t complete compilation of this initializer'].
	method containingEnvironment: self namedReferent.
	(newString := newString copy)
		nextPut: 'foo';
		nextPut: 'bar';
		nextPut: 'zork'.
	^BlockClosure newCleanMethod: method! !

TestClassRoot subclass: #TestClassWithAttributedMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!TestClassWithAttributedMethod methodsFor: 'attributed methods' stamp: 'sp 24/10/11 15:26'!
method1
	
	<test: #itsatest>
	! !

!TestClassWithAttributedMethod methodsFor: 'attributed methods' stamp: 'sp 24/10/11 15:26'!
method2
	
	<symbol: #asymbol>
	<string: 'A String'>
	<x: 1 y: 2>
	<array: #(1 #a 'test')>
	
	! !

TestClassRoot subclass: #Tree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

Tree subclass: #Leaf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!Leaf methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isLeaf
	
	^true! !

Tree subclass: #Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

!Node methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isNode
	
	^true! !

!Tree methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isLeaf
	
	^false! !

!Tree methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isNode
	
	^false! !

TestClassRoot subclass: #TreeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

TreeVisitor subclass: #PrintVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!

TreeVisitor subclass: #SaveVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LiCoR-Tests'!
